import response_codes as codes
import utility_integration as util
import sys

sys.path.append("../../../../tests")

class test_access_control_cli(util.WrapTest):
    def test_access_control_cli_base_functionality(self):
        base_url = "/system/access_control/cli/config"
        with self.subTest("configure_section"):
            x = self.put_data(base_url + "/general", {
                "enable":"1",
                "_cliWanAccess":"1",
                "port":"4100-4240",
                "shell_limit":"6"
            })
            x.assert_data({
                "id":"general",
                ".type":"status",
                "enable":"1",
                "_cliWanAccess":"1",
                "port":"4100-4240",
                "shell_limit":"6"
            })
        with self.subTest("single_get"):
            x = self.get(base_url + "/general")
            x.assert_data({
                "id":"general",
                ".type":"status",
                "enable":"1",
                "_cliWanAccess":"1",
                "port":"4100-4240",
                "shell_limit":"6"
            })
        with self.subTest("multiple_get"):
            x = self.get(base_url)
            x.assert_data([{
                "id":"general",
                ".type":"status",
                "enable":"1",
                "_cliWanAccess":"1",
                "port":"4100-4240",
                "shell_limit":"6"
            }])
        with self.subTest("clear_configuration"):
            x = self.put_data(base_url + "/general", {
                "_cliWanAccess":"",
                "shell_limit":"5",
                "port":"4200-4220"
            })
            x.assert_data({
                "id":"general",
                ".type":"status",
                "enable":"1",
                "port":"4200-4220",
                "shell_limit":"5"
            })
        with self.subTest("test_ac_cli_deletion"):
            x = self.delete(base_url)
            x.assert_error("Validation", "Section deletion is not allowed", 111, None, None)
        with self.subTest("test_ac_cli_creation"):
            x = self.post_data(base_url, {})
            x.assert_error("Validation", "Section creation is not allowed", 108, None, None)
