import response_codes as codes
import utility_integration as util
import sys
from utils.ssh import open_ssh_connection, send_cmd
import time

sys.path.append("../../../../tests")

class test_access_control_login_attempts(util.WrapTest):
    def test_access_control_login_attempts_actions(self):
        base_url = "/system/access_control/security/attempts"
        env = util.Env
        with self.subTest("get_login_attempts"):
            with open_ssh_connection() as ssh:
                send_cmd(ssh, "ubus call ip_block push '{\"ip\":\"8.8.8.8\",\"destination_ip\":\"" + env.ip + "\",\"port\":\"22\"}'")
            time.sleep(0.5)
            x = self.get(base_url + "/config")
            x.assert_data([{
                ".type":"entry",
                "port":"22",
                "counter":"1",
                "destination_ip":"192.168.1.1",
                "ip":"8.8.8.8",
                "proto":"ssh"
            }], 200, {"id"})
        with self.subTest("unblock_all"):
            x = self.post(base_url + "/actions/unblock_all", {})
            x.assert_data({
                "response":"ok"
            })
        with self.subTest("multiple_get"):
            x = self.get(base_url + "/config")
            x.assert_data([])
