import response_codes as codes
import utility_integration as util
import sys

sys.path.append("../../../../tests")

class test_access_control_login_attempts_general(util.WrapTest):
    def test_access_control_login_attempts_general_base_functionality(self):
        base_url = "/system/access_control/security/general/config"
        with self.subTest("configure_section"):
            x = self.put_data(base_url + "/general", {
                "enabled":"1",
                "reboot_clear":"1",
                "max_attempt_count":"69"
            })
            x.assert_data({
                "id":"general",
                ".type":"globals",
                "enabled":"1",
                "reboot_clear":"1",
                "max_attempt_count":"69"
            })
        with self.subTest("single_get"):
            x = self.get(base_url + "/general")
            x.assert_data({
                "id":"general",
                ".type":"globals",
                "enabled":"1",
                "reboot_clear":"1",
                "max_attempt_count":"69"
            })
        with self.subTest("multiple_get"):
            x = self.get(base_url)
            x.assert_data([{
                "id":"general",
                ".type":"globals",
                "enabled":"1",
                "reboot_clear":"1",
                "max_attempt_count":"69"
            }])
        with self.subTest("clear_configuration"):
            x = self.put_data(base_url + "/general", {
                "reboot_clear":"",
                "max_attempt_count":"10"
            })
            x.assert_data({
                "id":"general",
                ".type":"globals",
                "enabled":"1",
                "max_attempt_count":"10"
            })
        with self.subTest("test_ac_la_general_deletion"):
            x = self.delete(base_url)
            x.assert_error("Validation", "Section deletion is not allowed", 111, None, None)
        with self.subTest("test_ac_la_general_creation"):
            x = self.post_data(base_url, {})
            x.assert_error("Validation", "Section creation is not allowed", 108, None, None)
