import response_codes as codes
import utility_integration as util
import sys

sys.path.append("../../../../tests")

class test_access_control_ssh(util.WrapTest):
    def test_access_control_ssh_base_functionaliy(self):
        base_url = "/system/access_control/ssh/config"
        with self.subTest("configure_section"):
            x = self.put_data(base_url + "/general", {
                "enable":"1",
                "_sshWanAccess":"1",
                "port":"420",
                "ssh_keys":"testKeys",
                "enable_key_ssh":"1"
            })
            x.assert_data({
                ".type":"dropbear",
                "enable":"1",
                "_sshWanAccess":"1",
                "port":"420",
                "ssh_keys":"testKeys",
                "enable_key_ssh":"1",
                "id":"general"
            })
        with self.subTest("single_get"):
            x = self.get(base_url + "/general")
            x.assert_data({
                ".type":"dropbear",
                "enable":"1",
                "_sshWanAccess":"1",
                "port":"420",
                "ssh_keys":"testKeys",
                "enable_key_ssh":"1",
                "id":"general"
            })
        with self.subTest("multiple_get"):
            x = self.get(base_url)
            x.assert_data([{
                ".type":"dropbear",
                "enable":"1",
                "_sshWanAccess":"1",
                "port":"420",
                "ssh_keys":"testKeys",
                "enable_key_ssh":"1",
                "id":"general"
            }])
        with self.subTest("clear_configuration"):
            x = self.put_data(base_url + "/general", {
                "enable":"1",
                "_sshWanAccess":"",
                "port":"22",
                "enable_key_ssh":"",
                "ssh_keys":""
            })
            x.assert_data({
                "id":"general",
                ".type":"dropbear",
                "enable":"1",
                "port":"22"
            })
        with self.subTest("test_ac_ssh_deletion"):
            x = self.delete(base_url)
            x.assert_error("Validation", "Section deletion is not allowed", 111, None, None)
        with self.subTest("test_ac_ssh_creation"):
            x = self.post_data(base_url, {})
            x.assert_error("Validation", "Section creation is not allowed", 108, None, None)
