import sys
import utility_integration as util
sys.path.append("../../../../tests")

class test_administration_general(util.WrapTest):

    def test_administration_general_base_functionality(self):
        base_url = "/system/administration/general/config"
        with self.subTest("multiple_get"):
            x = self.get(base_url)
            x.assert_data([{
                ".type":"core",
                "firstlogin":"0",
                "id":"general",
                "lang":"en"
            }])
        with self.subTest("single_get"):
            x = self.get(base_url + "/general")
            x.assert_data({
                ".type":"core",
                "firstlogin":"0",
                "id":"general",
                "lang":"en"
            })
        with self.subTest("configure_administration_general"):
            x = self.put_data(base_url + "/general", {
                "advanced":"1"
            })
            x.assert_data({
                ".type":"core",
                "firstlogin":"0",
                "id":"general",
                "lang":"en",
                "advanced":"1"  
            })
        with self.subTest("get_configured"):
            x = self.get(base_url + "/general")
            x.assert_data({
                ".type":"core",
                "firstlogin":"0",
                "id":"general",
                "lang":"en",
                "advanced":"1"  
            })
        with self.subTest("return_configuration"):
            x = self.put_data(base_url + "/general", {
                "advanced":""
            })
            x.assert_data({
                ".type":"core",
                "firstlogin":"0",
                "id":"general",
                "lang":"en",
            })
    
    def test_administration_general_deletion(self):
        x = self.delete("/system/administration/general/config")
        x.assert_error("Validation", "Section deletion is not allowed", 111, None, None)
    def test_administration_general_creation(self):
        x = self.post_data("/system/administration/general/config", {})
        x.assert_error("Validation", "Section creation is not allowed", 108, None, None)