import sys
import utility_integration as util
import response_codes as codes

sys.path.append("../../../../tests")

class test_backup(util.WrapTest):
    def test_backup_base(self):
        base_url = "/system/backup"
        date = ""
        md5 = ""
        sha256 = ""
        with self.subTest("create_default_date"):
            x = self.post(base_url + "/actions/create_default", None)
            resp = x.resp
            date = resp.json()["data"]["date"]
            self.assertIn("date", resp.json()["data"])
        with self.subTest("get_default_date"):
            x = self.get(base_url + "/status/default")
            x.assert_data({
                "date":date
            })
        with self.subTest("generate_backup"):
            x = self.post(base_url + "/actions/generate_backup", None)
            resp = x.resp
            md5 = resp.json()["data"]["md5"]
            sha256 = resp.json()["data"]["sha256"]
            self.assertIn("md5", resp.json()["data"])
            self.assertIn("sha256", resp.json()["data"])
        with self.subTest("validate_backup"):
            x = self.post(base_url + "/actions/validate_backup", None)
            x.assert_data({
                "result":"0",
                "md5":md5,
                "sha256":sha256
            })
        with self.subTest("get_all"):
            x = self.get(base_url + "/status")
            x.assert_data({
                "date":date,
                "md5":md5,
                "sha256":sha256
            })
        with self.subTest("remove_default_date"):
            x = self.post(base_url + "/actions/remove_default", None)
            x.assert_data({
                "date":""
            })
        with self.subTest("remove_backup"):
            x = self.post(base_url + "/actions/remove_backup", None)
            x.assert_data({
                "md5":"-",
                "sha256":"-"
            })
