import sys
import utility_integration as util
sys.path.append("../../../../tests")

class test_profiles(util.WrapTest):
    base_url = "/system/profiles/config"

    def test_profiles_base_functionality(self):
        with self.subTest("create_profile"):
            x = self.post_data(self.base_url, {
                "id":"testProfile",
                "from_current_profile":"1"
            })
            x.assert_data({
                ".type": "profile",
                "profile_id": "1",
                "id": "testProfile"
            }, 201, {"updated"})
        with self.subTest("get_profiles"):
            x = self.get(self.base_url)
            x.assert_data([
                {
                    ".type": "profile",
                    "profile_id": "0",
                    "id": "default"
                },
                {
                    ".type": "profile",
                    "profile_id": "1",
                    "id": "testProfile"
                }
            ], 200, {"updated"})
        with self.subTest("change_profile"):
            x = self.post_data("/system/profiles/actions/apply_profile", {
                "name":"testProfile"
            })
            x.assert_data({
                "lan_ip":util.Env().ip
            })
        with self.subTest("get_current_profile"):
            x = self.get("/system/profiles/status")
            x.assert_data({
                "current_profile":"testProfile"
            })
        with self.subTest("return_to_default"):
            x = self.post_data("/system/profiles/actions/apply_profile", {
                "name":"default"
            })
            resp = x.resp
            while resp.status_code != 200:
                x = self.post_data("/system/profiles/actions/apply_profile", {
                    "name":"default"
                })
                resp = x.resp
            x.assert_data({
                "lan_ip":util.Env().ip
            })
        with self.subTest("delete_testProfile"):
            x = self.delete(self.base_url + "/testProfile")
            x.assert_data({
                "id":"testProfile"
            })
        with self.subTest("try_profiles_put"):
            x = self.put_data(self.base_url + "/default", {
                "test":"test"
            })
            x.assert_error("Request", "PUT not implemented", 100)