import sys
import utility_integration as util
sys.path.append("../../../../tests")

class test_scheduler_general(util.WrapTest):


    def test_scheduler_general_base_functionality(self):
        base_url = "/system/profiles_scheduler_general/config"
        with self.subTest("get_multiple"):
            x = self.get(base_url)
            x.assert_data([{
                ".type": "general",
                "id": "general"
            }])
        with self.subTest("get_single"):
            x = self.get(base_url + "/general")
            x.assert_data({
                ".type": "general",
                "id": "general"
            })
        with self.subTest("modify"):
            x = self.put_data(base_url + "/general", {
                "enabled": "1",
            })
            x.assert_data({
                ".type": "general",
                "id": "general",
                "enabled": "1"
            })
        with self.subTest("return_configuration"):
            x = self.put_data(base_url + "/general", {
                "enabled": ""
            })
            x.assert_data({
                ".type": "general",
                "id": "general"
            })
        
    def test_administration_general_deletion(self):
        x = self.delete("/system/profiles_scheduler_general/config")
        x.assert_error("Validation", "Section deletion is not allowed", 111, None, None)
    def test_administration_general_creation(self):
        x = self.post_data("/system/profiles_scheduler_general/config", {})
        x.assert_error("Validation", "Section creation is not allowed", 108, None, None)