import sys
import utility_integration as util
import response_codes as codes
sys.path.append("../../../../tests")

class troubleshoot(util.WrapTest):

    base_url = "/system/troubleshoot"
    def test_troubleshoot_base_functionality(self):
        with self.subTest("multiple_get"):
            x = self.get(self.base_url + "/config")
            x.assert_data([{
                "id":"general",
                ".type":"system"
            }])
        with self.subTest("single_get"):
            x = self.get(self.base_url + "/config/general")
            x.assert_data({
                "id":"general",
                ".type":"system"
            })
        with self.subTest("modify_troubleshoot"):
            x = self.put_data(self.base_url + "/config/general", {
                "tcp_dump":"1",
                "tcp_dump_interface":"eth0",
                "tcp_dump_filter":"arp",
                "tcp_inout":"inout",
                "tcp_mount":"/tmp",
                "tcp_host":"8.8.8.8",
                "tcp_port":"80"
            })
            x.assert_data({
                "id":"general",
                ".type":"system",
                "tcp_dump":"1",
                "tcp_dump_interface":"eth0",
                "tcp_dump_filter":"arp",
                "tcp_inout":"inout",
                "tcp_mount":"/tmp",
                "tcp_host":"8.8.8.8",
                "tcp_port":"80"
            })
        with self.subTest("get_modified"):
            x = self.get(self.base_url + "/config/general")
            x.assert_data({
                "id":"general",
                ".type":"system",
                "tcp_dump":"1",
                "tcp_dump_interface":"eth0",
                "tcp_dump_filter":"arp",
                "tcp_inout":"inout",
                "tcp_mount":"/tmp",
                "tcp_host":"8.8.8.8",
                "tcp_port":"80"
            })
        with self.subTest("return_configuration"):
            x = self.put_data(self.base_url + "/config/general", {
                "tcp_dump":"",
                "tcp_dump_interface":"",
                "tcp_dump_filter":"",
                "tcp_inout":"",
                "tcp_mount":"",
                "tcp_host":"",
                "tcp_port":""
            })
            x.assert_data({
                "id":"general",
                ".type":"system"
            })

    def test_log_gets(self):
        with self.subTest("test_kernel_log"):
            x = self.get(self.base_url + "/kernel_log")
            x.assert_code(200)
        with self.subTest("test_system_log"):
            x = self.get(self.base_url + "/system_log")
            x.assert_code(200)

    def test_troubleshoot_deletion(self):
        x = self.delete(self.base_url + "/config")
        x.assert_error("Validation", "Section deletion is not allowed", 111, None, None)
    def test_troubleshoot_creation(self):
        x = self.post_data(self.base_url + "/config", {})
        x.assert_error("Validation", "Section creation is not allowed", 108, None, None)