. /lib/functions/failsafeboot.sh

REQUIRE_IMAGE_METADATA=1

nand_upgrade_ubi_fsb() {
	local ubi_file="$1"
	local mtdnum="$(find_mtd_index "$CI_UBIPART")"
	local attempts_limit=30

	if [ ! "$mtdnum" ]; then
		echo "cannot find mtd device $CI_UBIPART"
		umount -a
		reboot -f
	fi

	fwtool -q -t -i /dev/null "$1"

	local mtddev="/dev/mtd${mtdnum}"
	while [ $attempts_limit -gt 0 ]; do
		ubidetach -p "${mtddev}" 2>/dev/null && break
		attempts_limit=$((attempts_limit-1))
		sleep 1
	done
	sync
	fsb_upgrade_begin $CI_UBIPART

	ubiformat "${mtddev}" -y -f "${ubi_file}"
	if [ "$?" -ne 0 ]; then
		echo "Error writing to $CI_UBIPART"
		umount -a
		reboot -f
	fi

	ubiattach -p "${mtddev}"

	local conf_tar="/tmp/sysupgrade.tgz"
	sync
	[ -f "$conf_tar" ] && nand_restore_config "$conf_tar"
	echo "sysupgrade successful"

	fsb_upgrade_finalize $CI_UBIPART
	umount -a
	reboot -f
}

platform_check_image() {
	return 0
}

platform_do_upgrade() {
	CI_UBIPART="$(fsb_get_upgrade_slot)"
	nand_upgrade_ubi_fsb "$1"
}
